<script>
export default {
  name: 'CaseStudyTabs',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      selectedTab: 0,
    };
  },
  methods: {
    selectTab(index) {
      this.selectedTab = index;
    },
  },
};
</script>

<template>
  <SlpContainer>
    <section class="tabs-section-wrapper">
      <SlpTypography id="tab-label" variant="heading2-bold" tag="h2">
        {{ data.heading }}
      </SlpTypography>
      <div class="tabs">
        <div class="tablist" role="tablist" aria-labelledby="tab-label">
          <button
            v-for="(tab, index) in data.tabs"
            :id="`${tab.tab}-tab`"
            :key="tab.tab"
            role="tab"
            :class="['tab', index === selectedTab ? 'selected' : '']"
            :aria-selected="index === selectedTab ? 'true' : 'false'"
            :tabindex="index === selectedTab ? '-1' : '0'"
            :aria-controls="`${tab.tab}-tabpanel`"
            @click="selectTab(index)"
          >
            {{ tab.tab }}
          </button>
        </div>
        <div
          v-for="(tabContent, index) in data.tabs"
          v-show="index === selectedTab"
          :id="`${tabContent.tab}-tabpanel`"
          :key="tabContent.tab"
          class="tabpanel"
          :style="{ 'border-top-left-radius': selectedTab > 0 ? '8px' : '0' }"
          :aria-labelledby="`${tabContent.tab}-tab`"
        >
          <SlpTypography
            variant="heading3-bold"
            tag="h3"
            class="slp-mb-16 slp-mt-8"
            >{{ tabContent.title }}</SlpTypography
          >
          <SlpTypography
            v-if="tabContent.text"
            variant="heading5"
            tag="p"
            class="slp-mb-24"
          >
            {{ tabContent.text }}
          </SlpTypography>
          <SlpButton
            variant="primary"
            :href="tabContent.cta.url"
            :data-ga-name="tabContent.cta.data_ga_name"
            :data-ga-location="tabContent.cta.data_ga_location"
          >
            {{ tabContent.cta.text }}
            <SlpIcon
              class="slp-ml-8"
              size="sm"
              variant="product"
              name="chevron-lg-right"
            />
          </SlpButton>
          <div
            :class="[
              'case-study-cards',
              tabContent.tab == 'Teachers' && 'teachers',
            ]"
          >
            <article
              v-for="card in tabContent.cards"
              :key="card.title"
              class="case-study-card"
            >
              <div v-if="card.icon_name || card.icon_url">
                <SlpIcon
                  v-if="card.icon_name"
                  :icon="card.icon_name"
                  class="icon"
                  size="md"
                  color="surface-700"
                />
                <nuxt-img
                  v-if="card.icon_url"
                  class="icon"
                  :src="card.icon_url"
                  aria-hidden="true"
                  alt=""
                  format="webp"
                  quality="99"
                />
              </div>
              <SlpTypography variant="heading4-bold" tag="h4">
                {{ card.title }}
              </SlpTypography>
              <SlpTypography tag="span" variant="body1">
                <div v-html="$md.render(card.text)"></div>
              </SlpTypography>
              <SlpButton
                variant="tertiary"
                :href="card.cta.url"
                :data-ga-name="card.cta.data_ga_name"
                :data-ga-location="card.cta.data_ga_location"
              >
                {{ card.cta.text }}
                <SlpIcon variant="product" name="chevron-lg-right" />
              </SlpButton>
            </article>
          </div>
        </div>
      </div>
    </section>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.tabs-section-wrapper {
  background: $color-surface-800;
  padding: $spacing-96 0;
  position: relative;

  @media (max-width: $breakpoint-md) {
    padding: $spacing-48 0;
  }

  &:before {
    content: '';
    position: absolute;
    height: 100%;
    width: 9999px;
    top: 0;
    right: 0;
    background: $color-surface-800;
    z-index: -1;
  }

  &:after {
    content: '';
    position: absolute;
    height: 100%;
    width: 9999px;
    top: 0;
    left: 0;
    background: $color-surface-800;
    z-index: -1;
  }
}

.tabs {
  margin-top: $spacing-32;

  .tablist {
    display: flex;
  }

  .tab {
    border: none;
    cursor: pointer;
    color: $color-text-300;
    font-size: $text-body-1;
    line-height: $line-height-body-1;
    padding: $spacing-24;
    border-top: 3px solid transparent;

    &:hover {
      border-top: 3px solid $color-accent-400;
      font-weight: $font-weight-bold;
    }

    &.selected {
      background: $color-surface-50;
      border-top: 3px solid $color-accent-500;
      font-weight: $font-weight-bold;
    }

    @media (max-width: $breakpoint-md) {
      padding: $spacing-16;
    }
  }

  .tabpanel {
    padding: $spacing-32;
    background: $color-surface-50;
    border-radius: 0 8px 8px 8px;

    .slp-btn-primary {
      margin-bottom: $spacing-32;
    }

    @media (max-width: $breakpoint-md) {
      padding: $spacing-16;

      .slp-btn-primary {
        width: 100%;
        justify-content: center;
      }
    }
  }

  .case-study-cards {
    margin-top: $spacing-8;
    display: flex;
    flex-wrap: wrap;
    justify-content: space-between;
    gap: 30px 32px;
  }

  .case-study-cards.teachers .case-study-card {
    flex: 1 0 100%;
  }

  .case-study-card {
    flex: 1 0 45%;
    padding: $spacing-32;
    border-radius: 8px;
    border: 1px solid $color-surface-300;
    display: flex;
    flex-direction: column;
    justify-content: space-between;

    .icon {
      margin-bottom: $spacing-16;
      max-width: 28px;
      max-height: 28px;
    }

    h4 {
      margin-bottom: $spacing-16;
    }

    .slp-btn {
      margin-top: $spacing-32;
      padding-left: 0;
    }

    @media (max-width: $breakpoint-md) {
      .slp-btn {
        text-align: left;
      }
    }

    :deep {
      p {
        margin-bottom: $spacing-24;
      }
      ul {
        list-style: disc;
        margin-left: $spacing-32;
        @media (max-width: $breakpoint-md) {
          margin-left: $spacing-24;
        }
      }

      ul li {
        font-size: 16px;
        line-height: 24px;
        margin-bottom: $spacing-16;
      }
    }
  }
}
</style>
